## dpdk 17.05.2

=== drivers/crypto/dpaa2_sec/Makefile ===
#   BSD LICENSE
#
#   Copyright (c) 2016 Freescale Semiconductor, Inc. All rights reserved.
#   Copyright (c) 2016 NXP. All rights reserved.
#
#   Redistribution and use in source and binary forms, with or without
#   modification, are permitted provided that the following conditions
#   are met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in
#       the documentation and/or other materials provided with the
#       distribution.
#     * Neither the name of Freescale Semiconductor, Inc nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

include $(RTE_SDK)/mk/rte.vars.mk

#
# library name
#
LIB = librte_pmd_dpaa2_sec.a

# build flags
ifeq ($(CONFIG_RTE_LIBRTE_DPAA2_SEC_DEBUG_INIT),y)
CFLAGS += -O0 -g
CFLAGS += "-Wno-error"
else
CFLAGS += -O3
CFLAGS += $(WERROR_FLAGS)
endif
CFLAGS += -D _GNU_SOURCE

ifeq ($(shell test $(GCC_VERSION) -gt 70 && echo 1), 1)
CFLAGS += -Wno-implicit-fallthrough
endif

CFLAGS += -I$(RTE_SDK)/drivers/crypto/dpaa2_sec/
CFLAGS += -I$(RTE_SDK)/drivers/crypto/dpaa2_sec/mc
CFLAGS += -I$(RTE_SDK)/drivers/bus/fslmc/
CFLAGS += -I$(RTE_SDK)/drivers/bus/fslmc/qbman/include
CFLAGS += -I$(RTE_SDK)/drivers/bus/fslmc/mc
CFLAGS += -I$(RTE_SDK)/drivers/bus/fslmc/portal
CFLAGS += -I$(RTE_SDK)/drivers/mempool/dpaa2/
CFLAGS += -I$(RTE_SDK)/lib/librte_eal/linuxapp/eal

# versioning export map
EXPORT_MAP := rte_pmd_dpaa2_sec_version.map

# library version
LIBABIVER := 1

# library source files
SRCS-$(CONFIG_RTE_LIBRTE_PMD_DPAA2_SEC) += dpaa2_sec_dpseci.c
SRCS-$(CONFIG_RTE_LIBRTE_PMD_DPAA2_SEC) += mc/dpseci.c

# library dependencies
DEPDIRS-$(CONFIG_RTE_LIBRTE_PMD_DPAA2_SEC) += lib/librte_eal
DEPDIRS-$(CONFIG_RTE_LIBRTE_PMD_DPAA2_SEC) += lib/librte_mempool lib/librte_mbuf
DEPDIRS-$(CONFIG_RTE_LIBRTE_PMD_DPAA2_SEC) += lib/librte_cryptodev
DEPDIRS-$(CONFIG_RTE_LIBRTE_PMD_DPAA2_SEC) += drivers/bus/fslmc
DEPDIRS-$(CONFIG_RTE_LIBRTE_PMD_DPAA2_SEC) += drivers/mempool/dpaa2

LDLIBS += -lrte_bus_fslmc
LDLIBS += -lrte_mempool_dpaa2

include $(RTE_SDK)/mk/rte.lib.mk

=== debian/changelog ===
dpdk (17.05.2-0ubuntu1.1~cloud0) xenial-pike; urgency=medium

  * New update for the Ubuntu Cloud Archive.

 -- Openstack Ubuntu Testing Bot <openstack-testing-bot@ubuntu.com>  Wed, 16 May 2018 14:34:09 +0000

dpdk (17.05.2-0ubuntu1.1) artful-security; urgency=medium

  * SECURITY UPDATE: incorrect bounds checking
    - debian/patches/CVE-2018-1059-*.patch: backported upstream patches.
    - CVE-2018-1059

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 24 Apr 2018 07:23:26 -0400

dpdk (17.05.2-0ubuntu1) artful; urgency=medium

  * New upstream stable release 17.05.2 (LP: #1716667)
    In Debian we moved already to 17.08.x in experimental so no syncs anymore
    for Artful. This fixes a lot of issues, for an overview see the announce
    mail at: http://dpdk.org/ml/archives/announce/2017-September/000144.html
  * d/p/bug-1716666-eal-pci-introduce-a-PCI-driver-flag.patch,
    d/p/bug-1716666-net-thunderx-manage-PCI-device-mapping-for-SQS-VFs.patch:
    let devices flag to not be unmapped e.g. needed for thunderX secondary
    queues (LP: #1716666).
  * d/librte-ethdev17.05.symbols: add rte_eth_tx_done_cleanup which was
    exported but missing in the maps, that got fixed in 17.05.2 - adapt the
    symbols file to be correct.

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Tue, 12 Sep 2017 15:26:36 +0200

dpdk (17.05.1-4) experimental; urgency=medium

  [ Christian Ehrhardt ]
  * Fix d/p/fix-vhost-user-socket-permission.patch: add mis-dropped
    create_unix_socket call and reposition rte_eal_set_socket_permissions
  * Fix d/p/fix-vhost-user-socket-permission.patch
    - add accidenitally dropped create_unix_socket call
    - reposition rte_eal_set_socket_permissions to match 17.05 handling of
      vhost-user server sockets (and their late binding)

  [ Luca Boccassi ]
  * Mark build-dependencies needed for documentation builds with the <!nodoc>
    build-profile to fully implement support for it.
  * Bump Standards-Version to 4.1.0. Relevant changes are nodoc support and
    build reprodicibility.

 -- Luca Boccassi <luca.boccassi@gmail.com>  Wed, 23 Aug 2017 14:45:54 +0100

dpdk (17.05.1-3) experimental; urgency=medium

  [ Luca Boccassi ]
  * Fix reproducibility of librte-eal linuxapp.

  [ Christian Ehrhardt ]
  * d/rules: fix reference path of dpdk-devbind to match the new
    subdirectory which is in /usr/share/dpdk/usertools

 -- Luca Boccassi <luca.boccassi@gmail.com>  Fri, 18 Aug 2017 12:21:32 +0100

dpdk (17.05.1-2) experimental; urgency=medium

  * Install headers with arch-specific content in /usr/include/<multiarch>/dpdk
    to make libdpdk-dev multiarch-compliant.
    To ensure backward compatibility in x86_64, which is what most of the
    consumers use, symlink x86_64 headers in /usr/include/dpdk.
    pkg-config returns the arch-specific headers first so that other
    architectures are still compatible.
    Also create a full copy of the headers in the dpdk-dev SDK package, as it
    does not support multiple levels of headers.

 -- Luca Boccassi <luca.boccassi@gmail.com>  Wed, 09 Aug 2017 13:02:28 +0100

dpdk (17.05.1-1) experimental; urgency=medium

  [ Luca Boccassi ]
  * New Upstream release 17.05.1.
  * Add patches to make the libraries and PMDs builds fully reproducible,
    by making the listing order of headers, source files and objects in
    the makefiles stable (via sorting).

 -- Luca Boccassi <luca.boccassi@gmail.com>  Thu, 13 Jul 2017 18:43:12 +0100

dpdk (17.05-1) experimental; urgency=medium

  [ Christian Ehrhardt ]
  * New Upstream release 17.05; For a full list of changes (LP: #1691661)
    see http://dpdk.org/doc/guides/rel_notes/release_17_05.html
    - adapt to use MAJOR_ABI configuration to avoid the sub-lib abi
      version breakage of the past.
    - add d/update-helper* to update d/control and d/*.symbols for new versions
    - adapt to new build trigger and location of tests; provide further
      test tools (testacl, testpipeline) together with the already
      provided "test" tool in /usr/share/dpdk/test/ of dpdk-dev.
      Note: testpmd is installed "officially" by install-sdk and therefore
      stays separate from other test tools.
    - updated library arch availability/dependency: librte-kni is
      available on ppc64el; librte-pmd-i40e on all arches;
      librte-pmd-fm10k gone on ppc64el
    - package the 19 new sub-libs / pmds that are now built by default
    - rename and update symbols files to match the update to DPDK 17.05

  [ Luca Boccassi ]
  * Rename libraries after ABI major version rather than source version.
  * Always set CONFIG_RTE_MAJOR_ABI, even for custom config files as all the
    packaging is tuned around it.
  * Drop patches merged upstream and refresh
    fix-vhost-user-socket-permission.patch
  * Add patches to make the documentation and linker script builds fully
    reproducible. There are still reproducibility issues due to the use
    of __FILE__ and absolute paths.

 -- Luca Boccassi <luca.boccassi@gmail.com>  Thu, 22 Jun 2017 19:20:35 +0100

=== debian/control ===
Source: dpdk
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian DPDK Maintainers <pkg-dpdk-devel@lists.alioth.debian.org>
Uploaders: Luca Boccassi <luca.boccassi@gmail.com>,
           Christian Ehrhardt <christian.ehrhardt@canonical.com>,
           Santiago Ruano Rincón <santiagorr@riseup.net>
Build-Depends: debhelper (>= 9),
               dh-python,
               dh-systemd (>= 1.5),
               dkms,
               doxygen,
               graphviz,
               inkscape,
               libcap-dev,
               libpcap-dev,
               libxen-dev [amd64 arm64 i386],
               libxenstore3.0 [amd64 arm64 i386],
               python,
               python-sphinx,
               python-sphinx-rtd-theme,
               texlive-fonts-recommended,
               texlive-latex-extra
Standards-Version: 4.1.0
Section: libs
Homepage: http://www.dpdk.org
Vcs-Git: https://gerrit.fd.io/r/deb_dpdk
Vcs-Browser: https://gerrit.fd.io/r/gitweb?p=deb_dpdk.git

Package: dpdk
Section: admin
Architecture: amd64 arm64 i386 ppc64el
Depends: hwdata,
         lsb-base (>= 3.2-14),
         pciutils,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Recommends: ${librte:Recommends},
Suggests: dpdk-doc,
          dpdk-igb-uio-dkms (= ${binary:Version}),
          dpdk-rte-kni-dkms (= ${binary:Version}),
          linux-image-generic,
          python-pyelftools,
Description: Data Plane Development Kit (runtime)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime environment to run DPDK applications.

Package: dpdk-dev
Section: devel
Architecture: amd64 arm64 i386 ppc64el
Depends: libdpdk-dev (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Data Plane Development Kit (development files)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains examples and the upstream build environment. It is
 not strictly required in order to build external applications.

Package: dpdk-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Homepage: http://dpdk.org/doc/guides/index.html
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}, ${python:Depends}
Recommends: python, ${python:Recommends}
Description: Data Plane Development Kit (documentation)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the complete set of documentation and guides.

Package: dpdk-igb-uio-dkms
Section: kernel
Architecture: amd64 arm64 i386 ppc64el
Depends: dkms,
         dpdk-dev (= ${binary:Version}),
         libdpdk-dev (= ${binary:Version}),
         make,
         ${misc:Depends}
Description: Data Plane Development Kit (igb uio dkms)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the source code for the igb_uio kernel module.

Package: dpdk-rte-kni-dkms
Section: kernel
Architecture: amd64 arm64 i386 ppc64el
Depends: dkms,
         dpdk-dev (= ${binary:Version}),
         libdpdk-dev (= ${binary:Version}),
         make,
         ${misc:Depends}
Description: Data Plane Development Kit (rte kni dkms)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the source code for the rte_kni kernel module.

Package: libdpdk-dev
Section: libdevel
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpcap-dev,
         ${librte:Depends},
         ${misc:Depends}
Description: Data Plane Development Kit (basic development files)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the basic headers and library files required to
 build external applications which will also require at least SSE3 support
 when running.

Package: librte-ethdev17.05
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__ethdev_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (libethdev runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for libethdev.

Package: librte-acl17.05
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__acl_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-acl runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_acl.

Package: librte-cfgfile17.05
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__cfgfile_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-cfgfile runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_cfgfile.

Package: librte-cmdline17.05
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-cmdline runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_cmdline.

Package: librte-cryptodev17.05
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__cryptodev_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-cryptodev runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_cryptodev.

Package: librte-distributor17.05
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__distributor_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-distributor runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_distributor.

Package: librte-eal17.05
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__eal_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-eal runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_eal.

Package: librte-hash17.05
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__hash_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-hash runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_hash.

Package: librte-ip-frag17.05
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__ip__frag_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-ip-frag runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_ip_frag.

Package: librte-jobstats17.05
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__jobstats_8h_source.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-jobstats runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_jobstats.

Package: librte-kni17.05
Architecture: amd64 arm64 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__kni_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-kni runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_kni.

Package: librte-kvargs17.05
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__kvargs_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-kvargs runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_kvargs.

Package: librte-lpm17.05
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__lpm_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-lpm runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_lpm.

Package: librte-mbuf17.05
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__mbuf_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-mbuf2 runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte_mbuf.

Package: librte-mempool17.05
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: http://dpdk.org/doc/api/rte__mempool_8h.html
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libdpdk0
Description: Data Plane Development Kit (librte-mempool runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE=1
export DH_OPTIONS=-v

VERSION := $(shell dpkg-parsechangelog --show-field Version | sed -nr 's/(.*:)?([^-])(-.*)/\2/p')
DPDK_ABI := $(shell echo $(VERSION) | cut -d '.'  -f1-2)

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
include /usr/share/dpkg/default.mk

DEB_HOST_GNU_CPU := $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

# see ENVIRONMENT in dpkg-buildflags(1)
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Support backporting to jessie
dpkg_version_lt = $(shell dpkg --compare-versions $$(dpkg --status dpkg-dev | grep Version | cut -d' ' -f2) lt-nl "1.18.11" && echo yes)
ifeq (yes, $(dpkg_version_lt))
	# package maintainers to append CFLAGS
	# For Debian, dpkg-dev >= 1.18.11 and gcc 6.x, dpkg-buildflags and gcc
	# handle -fPIC and related flags relying on specs files
	# (/usr/share/dpkg/*specs)
	export DEB_CFLAGS_MAINT_APPEND  = -fPIC
	export EXTRA_CFLAGS=$(CFLAGS)
	export EXTRA_CPPFLAGS=$(CPPFLAGS)
	export HOST_EXTRA_CFLAGS=$(CFLAGS)
	export HOST_EXTRA_CPPFLAGS=$(CPPFLAGS)
	# need to be stripped as DPDK build system adds them and it would be -Wl,-Wl,opt
	export EXTRA_LDFLAGS=$(shell echo $(LDFLAGS) | sed 's/-Wl,//g')
	# HOST_CC build system does not add -Wl ...
	export EXTRA_HOST_LDFLAGS=$(LDFLAGS)
endif

export RTE_DEVEL_BUILD=n
export EXTRA_CFLAGS+=-g

# People rebuilding this package can overwrite DPDK_CONFIG, RTE_MACHINE and
# RTE_TARGET via DEB_BUILD_OPTIONS if they like
ifneq (,$(filter dpdk_config=%,$(DEB_BUILD_OPTIONS)))
    DPDK_CONFIG ?= $(patsubst dpdk_config=%,%,$(filter dpdk_config=%,$(DEB_BUILD_OPTIONS)))
endif
ifneq (,$(filter rte_machine=%,$(DEB_BUILD_OPTIONS)))
    RTE_MACHINE ?= $(patsubst rte_machine=%,%,$(filter rte_machine=%,$(DEB_BUILD_OPTIONS)))
endif
ifneq (,$(filter rte_target=%,$(DEB_BUILD_OPTIONS)))
    RTE_TARGET ?= $(patsubst rte_target=%,%,$(filter rte_target=%,$(DEB_BUILD_OPTIONS)))
endif

ifneq (,$(filter $(DEB_HOST_ARCH), arm64))
DPDK_CONFIG ?= "arm64-armv8a-linuxapp-gcc"
RTE_MACHINE ?= "armv8a"
RTE_TARGET ?= "arm64-armv8a-linuxapp-gcc"
INCLUDE_ARCH := arm
else
ifneq (,$(filter $(DEB_HOST_ARCH), ppc64el))
DPDK_CONFIG ?= "ppc_64-power8-linuxapp-gcc"
RTE_MACHINE ?= "power8"
RTE_TARGET ?= "ppc_64-power8-linuxapp-gcc"
INCLUDE_ARCH := ppc_64
else
DPDK_CONFIG ?= "$(DEB_HOST_GNU_CPU)-native-linuxapp-gcc"
RTE_MACHINE ?= "default"
RTE_TARGET ?= "$(DEB_HOST_GNU_CPU)-default-linuxapp-gcc"
INCLUDE_ARCH := x86
endif
endif
DPDK_STATIC_DIR = "debian/build/static-root"
DPDK_SHARED_DIR = "debian/build/shared-root"

# now stable with parallel comilation, so support -j
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    PAR := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(PAR)
endif

ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
BUILD_DOCS=n
else
BUILD_DOCS=y
endif

ifneq (,$(findstring nostatic,$(DEB_BUILD_OPTIONS)))
BUILD_STATIC_LIB=n
else
BUILD_STATIC_LIB=y
endif

# kernel_modules can be passed via DEB_BUILD_OPTIONS to enable building the
# optional binary kernel modules package. By default it will be built against
# the current kernel, or ksrc can be passed with a path to the target kernel
# sources instead.
ifeq (,$(findstring kernel_modules,$(DEB_BUILD_OPTIONS)))
DPDK_CONFIG_BUILD_KMOD=n
KSRC=""
else
ifneq (,$(filter ksrc=%,$(DEB_BUILD_OPTIONS)))
    KSRC := $(patsubst ksrc=%,%,$(filter ksrc=%,$(DEB_BUILD_OPTIONS)))
else
    KSRC := /lib/modules/$(shell uname -r)/build
endif

KVERS := $(shell perl debian/kernel-version $(KSRC))
export KVERS
export MODULE_CFLAGS=-fno-PIE

DPDK_CONFIG_BUILD_KMOD=y

# Since the binary module package is generated at build time depending on the
# local kernel version, we have to append the new package in d/control.
# We cannot use a separate control file since that wouldn't work with
# dpkg-genchanges, and also would require a lot of overrides for debhelpers.
get_built_using	?= $(filter-out (=),$(shell dpkg-query -f='$${source:Package} (=$${source:Version})' -W $1))

build:
	@if [ x"$(KVERS)" = x ] ; then \
	    echo 'No version in $(KSRC)/include/linux/version.h' >&2; \
	    exit 1; \
	fi
	sh debian/prep-modules $(KSRC)
	cat debian/control.modules >> debian/control
	dh $@ --with python2,dkms
endif

%:
	dh $@ --with python2,dkms

override_dh_gencontrol:
	dh_gencontrol
	# debian/files will not exist until dh_gencontrol has ran at least once,
	# so we need to run gencontrol for libdpdk-dev and libdpdk-dbgsym after.
	# The list of libraries and PMDs is everchanging, so generate the dependency
	# list for libdpdk-dev to avoid having to maintain it manually.
	# Same for the recommends list for dpdk, were we want the PMDs and the mempools.
	dh_gencontrol -p libdpdk-dev -- -V"librte:Depends=`grep -E 'librte-*' ./debian/files | grep -v dbgsym | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p dpdk -- -V"librte:Recommends=`grep -E 'librte-(pmd|mempool).*' ./debian/files | grep -v dbgsym | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
ifneq (,$(findstring kernel_modules,$(DEB_BUILD_OPTIONS)))
	dh_gencontrol -p dpdk-modules-$(KVERS) -- \
		-v`cat debian/VERSION` \
		-V'built:using:kernel=$(call get_built_using,linux-headers-$(KVERS))'
endif
ifneq (,$(findstring dbgsym_meta,$(DEB_BUILD_OPTIONS)))
	./debian/dh-dbgsym-metapkg libdpdk$(DPDK_ABI)-dbgsym
endif

# dbgsym_meta can be passed via DEB_BUILD_OPTIONS to enable building the
# optional dbgsym meta package libdpdk<ABI>-dbgsym.
# This is not built by default as it would go in main but depend on
# packages in the debian-debug archive.
# Debian Developers and FTP masters strongly discourage this.
# We provide this optional flag as a convenience for rebuilders.
ifneq (,$(findstring dbgsym_meta,$(DEB_BUILD_OPTIONS)))
override_dh_builddeb:
	dh_builddeb
	dh_builddeb -plibdpdk$(DPDK_ABI)-dbgsym
endif

override_dh_auto_clean:
	rm -rf debian/build debian/tmp debian/dpdk-modules-* \
		debian/control.modules debian/VERSION
	sed -i '/Package: dpdk-modules-/,/`tail -n1 debian/control.modules.in`/d' debian/control
	test -L config/defconfig_$(DPDK_CONFIG) && rm -f config/defconfig_$(DPDK_CONFIG) || true
	rm -f debian/dpdk-igb-uio-dkms.dkms debian/dpdk-rte-kni-dkms.dkms
	rm -f debian/dpdk-dev.preinst

override_dh_auto_configure:
	# Add support for a custom defconfig file in the debian directory.
ifneq (,$(filter dpdk_config=%,$(DEB_BUILD_OPTIONS)))
	test -e config/defconfig_$(DPDK_CONFIG) || ln -fs ../debian/defconfig_$(DPDK_CONFIG) config/defconfig_$(DPDK_CONFIG)
endif
	# report dpkg-buildflags status to build log
	dpkg-buildflags --status
	echo EXTRA_CFLAGS $$EXTRA_CFLAGS
	echo EXTRA_LDFLAGS: $$EXTRA_LDFLAGS
	$(MAKE) V=$(DH_VERBOSE) O=$(DPDK_STATIC_DIR) T=$(DPDK_CONFIG) config
ifeq (,$(filter dpdk_config=%,$(DEB_BUILD_OPTIONS)))
	sed -ri -e 's,(RTE_MACHINE=).*,\1$(RTE_MACHINE),' \
		-e 's,(RTE_NEXT_ABI=).*,\1n,' \
		-e 's,(CONFIG_RTE_EAL_IGB_UIO=).*,\1$(DPDK_CONFIG_BUILD_KMOD),' \
		-e 's,(CONFIG_RTE_KNI_KMOD=).*,\1$(DPDK_CONFIG_BUILD_KMOD),' \
		-e 's,(LIBRTE_PMD_PCAP=).*,\1y,' \
		-e 's,(LIBRTE_PMD_XENVIRT=).*,\1y,' \
		-e 's,(CONFIG_RTE_EAL_PMD_PATH=).*,\1"/usr/lib/$(DEB_HOST_MULTIARCH)/dpdk-pmds/",' \
		$(DPDK_STATIC_DIR)/.config
	# xen not available on ppc64el
ifneq (,$(filter $(DEB_HOST_ARCH), ppc64el))
	sed -ri -e 's,(LIBRTE_PMD_XENVIRT=).*,\1n,' $(DPDK_STATIC_DIR)/.config
endif
endif
	echo "CONFIG_RTE_MAJOR_ABI=\"$(DPDK_ABI)\"" >> \
		$(DPDK_STATIC_DIR)/.config
	dh_auto_configure

override_dh_auto_build-indep:
ifeq (y,$(BUILD_DOCS))
	$(MAKE) V=$(DH_VERBOSE) O=$(DPDK_STATIC_DIR) doc-api-html doc-guides-html
endif

override_dh_auto_install-indep:
	# Package: dpdk-doc
